	SUB FASTCGI_INPUT(STRING PARAMS(,), STDIN(,))
	! Copyright (c) 2002 Digital Synergy, Inc.
	! See the file LICENSE.TXT for information on usage and redistribution
	! of this file, and for a DISCLAIMER OF ALL WARRANTIES.

	%LET %BASIC$H_FLOATING_COMPLEX_DECL = 1
	%INCLUDE 'SYS$LIBRARY:UCX$INETDEF.BAS'

	!--------------------------------------------------------------
	! E X T E R N A L   D E C L A R A T I O N S
	!--------------------------------------------------------------

	EXTERNAL LONG FUNCTION		SYS$ASSIGN,		&
					SYS$DASSGN,		&
					SYS$QIO,		&
					SYS$QIOW

	EXTERNAL STRING FUNCTION 	DSI_URL_DECODE(STRING),	&
					SYSTEM_TIME_IN_HEX

	EXTERNAL LONG CONSTANT		SS$_CONNECFAIL,		&
					SS$_NORMAL,		&
					SS$_ENDOFFILE,		&
					SS$_LINKDISCON

	EXTERNAL WORD CONSTANT		IO$_ACCESS,		&
					IO$_READVBLK,		&
					IO$_WRITEVBLK,		&
					IO$M_ACCEPT


	!--------------------------------------------------------------
	! R E C O R D S
	!--------------------------------------------------------------

	RECORD DESC_TYPE
		LONG	CNT
		LONG	PTR
	END RECORD

	RECORD LOC_RECORD
	WORD	FAMILY
	WORD	PORT
	VARIANT
	CASE
		LONG	ADDR_LONG
	CASE
		STRING	ADDR_STR	= 4%
	CASE
		BYTE	ADDR(1% TO 4%)
	END VARIANT
	BYTE	X(1% TO 8%)
	END RECORD

	RECORD	PAR15_RECORD
	LONG	LEN15
	LONG	RET_REMOTE_ADR
	LONG	RET_LENGTH_ADDR
	END RECORD

	!--------------------------------------------------------------
	! C O N S T A N T S
	!--------------------------------------------------------------

	DECLARE BYTE CONSTANT		FCGI_BEGIN_REQUEST	= 1%,	&
					FCGI_ABORT_REQUEST	= 2%,	&
					FCGI_END_REQUEST	= 3%,	&
					FCGI_PARAMS		= 4%,	&
					FCGI_STDIN		= 5%,	&
					FCGI_STDOUT		= 6%,	&
					FCGI_STDERR		= 7%,	&
					FCGI_DATA		= 8%,	&
					FCGI_GET_VALUES		= 9%,	&
					FCGI_GET_VALUES_RESULT	= 10%,	&
					FCGI_UNKNOWN		= 11%

	DECLARE LONG CONSTANT	DUMP.CH	= 100%

	DECLARE STRING CONSTANT	CRLF	= CR + LF,			&
				CRLF2	= CR + LF + CR + LF,		&
				NULL8	= '0'C + '0'C + '0'C + '0'C	&
					+ '0'C + '0'C + '0'C + '0'C

	!--------------------------------------------------------------
	! M A P S
	!--------------------------------------------------------------

	%INCLUDE 'SOURCE:FASTCGI_COMMON_MAP.INC'

	MAP (FASTCGI_LOCATE_MAP)	STRING	MATCH_STRING	= 256%
	MAP (FASTCGI_LOCATE_MAP)	BYTE	MATCH_BYTE(1% TO 256%)

	!--------------------------------------------------------------
	! V A R I A B L E S
	!--------------------------------------------------------------

	DECLARE BYTE		REQ.TYPE

	DECLARE DESC_TYPE	STR

	DECLARE LONG		BOUNDARY.LEN,		&
				BUF.PTR,		&
				C0,			&
				CALL.STATUS,		&
				CONTENT.LEN,		&
				DATA.SIZE,		&
				J0,			&
				J1,			&
				J2,			&
				J3,			&
				J4,			&
				NAME.LEN,		&
				OUT.LEN,		&
				OUT.PTR,		&
				OUT.TYPE,		&
				PAD.LEN,		&
				PADDING,		&
				REQ.ID,			&
				RET.LEN,		&
				SEG.LEN,		&
				STDIN.TYPE,		&
				VALUE.LEN

	DECLARE WORD		IOSB(3%)

	DECLARE LOC_RECORD	REMOTE_ADR

	DECLARE PAR15_RECORD	PAR15

	DECLARE STRING		BOUNDARY,		&
				DUMP.STR,		&
				ERR.MESS,		&
				FILE.NAME,		&
				IN.DATA,		&
				OUT.DATA,		&
				PC.NAME,		&
				STDIN.STR,		&
				THIS.PARAM,		&
				THIS.VALUE,		&
				WORK.STR

	!--------------------------------------------------------------
	! F U N C T I O N S
	!--------------------------------------------------------------

	DEF LONG FASTCGI_LOCATE(LONG FL.START, STRING FL.STR)

	DECLARE LONG	FL.J0,	&
			FL.J1,	&
			FL.LEN,	&
			FL.M0

	MATCH_STRING	= FL.STR
	FL.LEN		= LEN(FL.STR)
	FL.M0		= 1%
	FL.J0		= FL.START

FIND_FIRST:
	IF STDIN_BYTE(FL.J0) <> MATCH_BYTE(FL.M0) THEN
		FL.J0	= FL.J0 + 1%
		GOTO FIND_FIRST IF FL.J0 <= STDIN_BUFPTR
		FASTCGI_LOCATE	= 0%
		EXIT DEF
	END IF

	FL.J1	= FL.J0

LOCATE_LOOP:
	FL.M0	= FL.M0 + 1%
	IF FL.M0 >  FL.LEN THEN
		FASTCGI_LOCATE	= FL.J0
		EXIT DEF
	END IF

	FL.J0	= FL.J0 + 1%
	IF FL.J0 > STDIN_BUFPTR THEN
		FASTCGI_LOCATE	= 0%
		EXIT DEF
	END IF

	GOTO LOCATE_LOOP	IF STDIN_BYTE(FL.J0) = MATCH_BYTE(FL.M0)

	FL.M0	= 1%
	FL.J0	= FL.J1 + 1%
	GOTO FIND_FIRST

	END DEF

	!--------------------------------------------------------------
	! I N I T I A L I Z A T I O N
	!--------------------------------------------------------------

	ON ERROR GOTO PROGRAM_ERROR

	DATA_ERROR	= 0%

	!--------------------------------------------------------------
	! Assign an INET device 
	!--------------------------------------------------------------

	ASSIGN_DEV:
	IF FASTCGI_CHANNEL_1 THEN
		CALL.STATUS     = SYS$DASSGN(FASTCGI_CHANNEL_1 BY VALUE)
	END IF

	! Assign channel used for communication
	CALL.STATUS	= SYS$ASSIGN('UCX$DEVICE:', FASTCGI_CHANNEL_1,,)
	CALL PGMERR('Assign status = ' + NUM1$(CALL.STATUS))	&
		IF CALL.STATUS <> SS$_NORMAL

	!--------------------------------------------------------------
	! Wait for Connect
	!--------------------------------------------------------------

CONNECT_WAIT:
	IF START_ELAPSED > 0. THEN
		THIS_ELAPSED	= TIME(0%) - START_ELAPSED
		TOTAL_ELAPSED	= TOTAL_ELAPSED + THIS_ELAPSED
		MAX_ELAPSED	= THIS_ELAPSED IF THIS_ELAPSED > MAX_ELAPSED
	END IF


	PAR15::LEN15		= 16%
	PAR15::RET_REMOTE_ADR	= LOC(REMOTE_ADR::FAMILY)
	PAR15::RET_LENGTH_ADDR	= LOC(RET.LEN)

	CALL.STATUS	= SYS$QIOW(,FASTCGI_CHANNEL BY VALUE,	&
		IO$_ACCESS OR IO$M_ACCEPT BY VALUE,	&
		IOSB() BY REF,,,	&
		,			! P1	&
		,			! P2	&
		PAR15::LEN15 BY REF,	! P3	&
		FASTCGI_CHANNEL_1 BY ref,	! P4	&
		,			! P5	&
		)			! P6

	CALL PGMERR('QIO CONNECT STATUS = ' + NUM1$(CALL.STATUS))	&
		IF CALL.STATUS <> SS$_NORMAL

!	PRINT
!	PRINT TIME$(0%) + ' ' &
!		+ num1$(ascii(mid(remote_adr::ADDR_STR, 1%, 1%))) + '.'	&
!		+ num1$(ascii(mid(remote_adr::ADDR_STR, 2%, 1%))) + '.'	&
!		+ num1$(ascii(mid(remote_adr::ADDR_STR, 3%, 1%))) + '.'	&
!		+ num1$(ascii(mid(remote_adr::ADDR_STR, 4%, 1%))) + ' ';

	START_ELAPSED	= TIME(0)

MAIN_LOOP:
	PARAM_PTR	= 0%
	STDIN_PTR	= 0%
	DATA.SIZE	= 0%

	GOSUB READ_DATA

	PRINT 'Data size = '; DATA.SIZE

	IF IOSB(0%) = SS$_LINKDISCON	&
	OR IOSB(0%) = SS$_CONNECFAIL THEN
		PRINT '****** DISCONNECT ******'
		CALL.STATUS     = SYS$DASSGN(FASTCGI_CHANNEL_1 BY VALUE)
		GOTO ASSIGN_DEV
	END IF

	HIT_COUNT	= HIT_COUNT + 1%
	BUF.PTR		= 1%
	STDIN_BUFPTR	= 0%

	SUBEXIT IF DATA_ERROR

DECODE_LOOP:
	IF BUF.PTR => DATA.SIZE THEN
		IF STDIN_BUFPTR > 0% THEN
			IF STDIN.TYPE = 1% THEN
				GOSUB DECODE_STDIN_M
			ELSE
				GOSUB DECODE_STDIN_A
			END IF
		END IF
		SUBEXIT
	END IF

	IF IN_BYTE(BUF.PTR) <> 1% THEN
		PRINT 'Version not 1'
		ERR.MESS	= 'Application logic error (1)'
		GOSUB LOG_ERROR
		GOTO MAIN_LOOP
	END IF
	BUF.PTR		= BUF.PTR + 1%

	REQ.TYPE	= IN_BYTE(BUF.PTR)
	BUF.PTR		= BUF.PTR + 1%

	REQ.ID		= ASCII(IN_CHAR(BUF.PTR))
	BUF.PTR		= BUF.PTR + 1%
	REQ.ID		= REQ.ID * 256% + ASCII(IN_CHAR(BUF.PTR))
	BUF.PTR		= BUF.PTR + 1%

	IF REQ.ID <> 1% THEN
		PRINT 'Request ID'; REQ.ID; 'received (not 1)'
		CALL PGMERR('Request ID not 1 : ' + NUM1$(REQ.ID))
	END IF

	CONTENT.LEN	= ASCII(IN_CHAR(BUF.PTR))
	BUF.PTR		= BUF.PTR + 1%
	CONTENT.LEN	= CONTENT.LEN * 256% + ASCII(IN_CHAR(BUF.PTR))
	BUF.PTR		= BUF.PTR + 1%

	PADDING		= ASCII(IN_CHAR(BUF.PTR))
	BUF.PTR		= BUF.PTR + 2%

	SELECT REQ.TYPE
	CASE FCGI_BEGIN_REQUEST
		BUF.PTR		= BUF.PTR + CONTENT.LEN + PADDING

	CASE FCGI_PARAMS
		GOSUB DECODE_PARAM IF CONTENT.LEN > 0%

	CASE FCGI_STDIN
		FOR J0	= BUF.PTR TO BUF.PTR + CONTENT.LEN - 1%
			IF STDIN_BUFPTR < IN_SIZE THEN
				STDIN_BUFPTR	= STDIN_BUFPTR + 1%
				STDIN_CHAR(STDIN_BUFPTR) = IN_CHAR(J0)
			ELSE
				ERR.MESS	= 'Input data too large (STDIN)'
				GOSUB LOG_ERROR
				GOTO MAIN_LOOP
			END IF
		NEXT J0
		BUF.PTR		= BUF.PTR + CONTENT.LEN + PADDING

	CASE FCGI_DATA
		PRINT 'DATA'
		BUF.PTR		= BUF.PTR + CONTENT.LEN + PADDING
		PRINT IN_BYTE(J0); FOR J0 = BUF.PTR TO BUF.PTR + CONTENT.LEN -1%

	CASE FCGI_ABORT_REQUEST
		PRINT 'ABORT'
		BUF.PTR		= BUF.PTR + CONTENT.LEN + PADDING
		PRINT IN_BYTE(J0); FOR J0 = BUF.PTR TO BUF.PTR + CONTENT.LEN -1%

	CASE FCGI_GET_VALUES_RESULT
		PRINT 'GET_VALUES_RESULT'
		BUF.PTR		= BUF.PTR + CONTENT.LEN + PADDING
		PRINT IN_BYTE(J0); FOR J0 = BUF.PTR TO BUF.PTR + CONTENT.LEN -1%

	! The rest of these types shouldn't be received
	CASE FCGI_END_REQUEST
		PRINT 'END'
		PRINT IN_BYTE(J0); FOR J0 = BUF.PTR TO BUF.PTR + CONTENT.LEN -1%
		BUF.PTR		= BUF.PTR + CONTENT.LEN + PADDING

	CASE FCGI_STDOUT
		PRINT 'STDOUT'
		PRINT IN_CHAR(J0); FOR J0 = BUF.PTR TO BUF.PTR + CONTENT.LEN -1%
		BUF.PTR		= BUF.PTR + CONTENT.LEN + PADDING

	CASE FCGI_STDERR
		PRINT 'STDERR'
		PRINT IN_CHAR(J0); FOR J0 = BUF.PTR TO BUF.PTR + CONTENT.LEN -1%
		BUF.PTR		= BUF.PTR + CONTENT.LEN + PADDING

	CASE FCGI_GET_VALUES
		PRINT 'GET_VALUES'
		PRINT IN_CHAR(J0); FOR J0 = BUF.PTR TO BUF.PTR + CONTENT.LEN- 1%
		BUF.PTR		= BUF.PTR + CONTENT.LEN + PADDING

	CASE ELSE
		PRINT 'UNKNOWN'
		PRINT IN_CHAR(J0); FOR J0 = BUF.PTR TO BUF.PTR + CONTENT.LEN -1%
		BUF.PTR		= BUF.PTR + CONTENT.LEN + PADDING

	END SELECT

	GOTO DECODE_LOOP

	!--------------------------------------------------------------
	! Perform a QIOW read operation
	!--------------------------------------------------------------

READ_DATA:
	CALL.STATUS = SYS$QIOW(,				&
		FASTCGI_CHANNEL_1 BY VALUE,			&
		IO$_READVBLK BY VALUE,				&
		IOSB() BY REF,,,				&
		LOC(IN_CHAR(1%)) + DATA.SIZE BY VALUE,	! P1	&
		5120% BY VALUE,				! P2	&
		,					! P3	&
		,					! P4	&
		,					! P5	&
		)					! P6


	CALL PGMERR('QIO READ STATUS = ' + NUM1$(CALL.STATUS))	&
		IF CALL.STATUS <> SS$_NORMAL


	SELECT IOSB(0%)
	CASE SS$_NORMAL
		! Fall thru
	CASE SS$_LINKDISCON, SS$_CONNECFAIL
		PRINT '%NET-F-LINK DISCONNECT/FAIL'
		RETURN
	CASE ELSE
		CALL PGMERR('QIO READ IOSB(0) = ' + NUM1$(IOSB(0%)))
	END SELECT

	DATA.SIZE	= DATA.SIZE + IOSB(1%)
	
	IF DATA.SIZE + 5120% > IN_SIZE THEN
		PRINT '%NET-F-DATA TOO LARGE'
		ERR.MESS	= 'Input data too large (READ_DATA)'
		DATA_ERROR	= -1%
		RETURN
	END IF

	IF IN_BYTE(DATA.SIZE - 7%) <> 1%	&
	OR (IN_BYTE(DATA.SIZE - 6%) <> 4% AND IN_BYTE(DATA.SIZE - 6%) <> 5%) &
	OR IN_BYTE(DATA.SIZE - 5%) <> 0%	&
	OR IN_BYTE(DATA.SIZE - 4%) <> 1%	&
	OR IN_BYTE(DATA.SIZE - 3%) <> 0%	&
	OR IN_BYTE(DATA.SIZE - 2%) <> 0% THEN
		GOTO READ_DATA
	END IF

	RETURN

	!--------------------------------------------------------------

DECODE_PARAM:
	GOSUB DECODE_LENGTH
	NAME.LEN	= SEG.LEN
	GOSUB DECODE_LENGTH
	VALUE.LEN	= SEG.LEN

	PARAM_PTR		= PARAM_PTR + 1%
	STR::CNT		= NAME.LEN
	STR::PTR		= LOC(IN_CHAR(1%)) + BUF.PTR - 1%
	IF STR::CNT >= 0% THEN
		CALL FASTCGI_GET_STR(STR::CNT BY REF, THIS.PARAM)
	ELSE
		PRINT '%NET-F-INVALID STRING COUNT ', STR::CNT
		THIS.PARAM	= ''
	END IF
	PARAMS(PARAM_PTR, 0%)	= THIS.PARAM

	STR::CNT		= VALUE.LEN
	STR::PTR		= LOC(IN_CHAR(1%)) + BUF.PTR - 1% + NAME.LEN
	IF STR::CNT >= 0% THEN
		CALL FASTCGI_GET_STR(STR::CNT BY REF, THIS.VALUE)
	ELSE
		PRINT '%NET-F-INVALID STRING COUNT ', STR::CNT
		THIS.VALUE	= ''
	END IF
	PARAMS(PARAM_PTR, 1%)	= THIS.VALUE

	BUF.PTR			= BUF.PTR + NAME.LEN + VALUE.LEN
	RETURN UNLESS	THIS.PARAM = 'CONTENT_TYPE'

	SELECT LEFT(THIS.VALUE, 9%)
	CASE 'applicati'
		STDIN.TYPE	= 0%
	CASE 'multipart'
		STDIN.TYPE	= 1%
		J0		= INSTR(0%, THIS.VALUE, '=')
		BOUNDARY	= RIGHT(THIS.VALUE, J0 + 1%)
		BOUNDARY.LEN	= LEN(BOUNDARY)
	CASE ELSE
		STDIN.TYPE	= 0%
		PRINT 'Unknown STDIN type '; PARAMS(PARAM_PTR, 1%)
	END SELECT

	RETURN

	!--------------------------------------------------------------

DECODE_LENGTH:
	IF IN_BYTE(BUF.PTR) >= 0% THEN
		SEG.LEN	= IN_BYTE(BUF.PTR)
		BUF.PTR	= BUF.PTR + 1%
		RETURN
	END IF
	SEG.LEN	= ASCII(IN_CHAR(BUF.PTR)) AND 127%
	BUF.PTR	= BUF.PTR + 1%

	SEG.LEN	= SEG.LEN * 256% + ASCII(IN_CHAR(BUF.PTR))
	BUF.PTR	= BUF.PTR + 1%

	SEG.LEN	= SEG.LEN * 256% + ASCII(IN_CHAR(BUF.PTR))
	BUF.PTR	= BUF.PTR + 1%

	SEG.LEN	= SEG.LEN * 256% + ASCII(IN_CHAR(BUF.PTR))
	BUF.PTR	= BUF.PTR + 1%

	RETURN

	!--------------------------------------------------------------

DECODE_STDIN_A:
	J1		= 0%

DECODE_STDIN_A_LOOP:
	STDIN.STR	= LEFT(STDIN_STR, STDIN_BUFPTR)

	J0	= INSTR(J1, STDIN.STR, '=')
	STDIN_PTR	= STDIN_PTR + 1%
	STDIN(STDIN_PTR, 0%)	= DSI_URL_DECODE(SEG$(STDIN.STR, J1+1%, J0-1%))

	! Locate its value
	J1	= INSTR(J0, STDIN.STR, '&')
	IF J1 = 0% THEN
		STDIN(STDIN_PTR, 1%)	= DSI_URL_DECODE(RIGHT(STDIN.STR,J0+1%))
		RETURN
	END IF
	STDIN(STDIN_PTR, 1%)	= DSI_URL_DECODE(SEG$(STDIN.STR, J0+1%, J1-1%))
	GOTO DECODE_STDIN_A_LOOP

	!--------------------------------------------------------------

DECODE_STDIN_M:
!	OPEN 'STDIN.DMP' FOR OUTPUT AS FILE DUMP.CH
!	DUMP.STR	= ' : '
!	FOR J0	= 1% TO STDIN_BUFPTR
!		C0	= STDIN_BYTE(J0)
!		C0	= 256% + C0 IF C0 < 0%
!
!		PRINT #DUMP.CH; FORMAT$(C0, ' ###');
!		IF C0 > 31% THEN
!			DUMP.STR	= DUMP.STR + CHR$(C0)
!		ELSE
!			DUMP.STR	= DUMP.STR + '.'
!		END IF
!		IF MOD(J0, 8%) = 0% THEN
!			PRINT #DUMP.CH; DUMP.STR
!			DUMP.STR	= FORMAT$(J0, '###### : ')
!		END IF
!	NEXT J0
!
!	CLOSE #DUMP.CH

	J1		= 1%

DECODE_STDIN_M_LOOP:
	! Locate first symbol
	IF J1 < 0% THEN
		PRINT '%NET-F-J1 IS NEG', J1
		RETURN
	END IF

	J0	= FASTCGI_LOCATE(J1, 'name=') + 2%
	RETURN IF J0 = 2%

	J2		= FASTCGI_LOCATE(J0, '"')

	STDIN_PTR	= STDIN_PTR + 1%
	STR::CNT	= J2 - J0
	STR::PTR	= LOC(STDIN_CHAR(1%)) + J0 - 1%
	IF STR::CNT >= 0% THEN
		CALL FASTCGI_GET_STR(STR::CNT BY REF, WORK.STR)
	ELSE
		PRINT '%NET-F-INVALID STRING COUNT ', STR::CNT
		WORK.STR	= ''
	END IF
	STDIN(STDIN_PTR, 0%)	= DSI_URL_DECODE(WORK.STR)

	! See if it's got a filename next
	J3	= FASTCGI_LOCATE(J2, 'filename=') + 2%
	J4	= FASTCGI_LOCATE(J2, CRLF)

	IF  J3 > 10%	&
	AND J3 < J4 THEN
		! Use filename as value
		GOTO SAVE_UPLOAD
	END IF
	
	! Locate its value
	J2		= J2 + 5%
	J1		= FASTCGI_LOCATE(J2, CRLF)
	STR::CNT	= J1 - J2 - 1%
	STR::PTR	= LOC(STDIN_CHAR(1%)) + J2 - 1%
	IF STR::CNT >= 0% THEN
		CALL FASTCGI_GET_STR(STR::CNT BY REF, WORK.STR)
	ELSE
		PRINT '%NET-F-INVALID STRING COUNT ', STR::CNT
		WORK.STR	= ''
	END IF
	STDIN(STDIN_PTR, 1%)	= DSI_URL_DECODE(WORK.STR)

	GOTO DECODE_STDIN_M_LOOP

SAVE_UPLOAD:
	! Put in filename as value
	J2	= FASTCGI_LOCATE(J3, '"')
	STR::CNT		= J2 - J3
	STR::PTR		= LOC(STDIN_CHAR(1%)) + J3 - 1%
	IF STR::CNT >= 0% THEN
		CALL FASTCGI_GET_STR(STR::CNT BY REF, WORK.STR)
	ELSE
		PRINT '%NET-F-INVALID STRING COUNT ', STR::CNT
		WORK.STR	= ''
	END IF
	STDIN(STDIN_PTR, 1%)	= DSI_URL_DECODE(WORK.STR)

	J2			= FASTCGI_LOCATE(J2, CRLF + CRLF) + 1%
		! Point to start of file data

	J1	= FASTCGI_LOCATE(J2, BOUNDARY) - LEN(BOUNDARY)
		! Get end of file

	PC.NAME		= EDIT$(STDIN(STDIN_PTR, 1%), 32%)
	GOTO DECODE_STDIN_M_LOOP IF PC.NAME = ''

	FILE.NAME	= '.UPL'
	FILE.NAME	= '.JPG' IF INSTR(0%, PC.NAME, '.JPG')
	FILE.NAME	= '.JPG' IF INSTR(0%, PC.NAME, '.JPEG')
	FILE.NAME	= '.GIF' IF INSTR(0%, PC.NAME, '.GIF')
	FILE.NAME	= '.TIF' IF INSTR(0%, PC.NAME, '.TIF')
	FILE.NAME	= 'CGI_UPLOAD:' + SYSTEM_TIME_IN_HEX + FILE.NAME

	PRINT PC.NAME + ' => ' + FILE.NAME

	WHEN ERROR IN
		OPEN FILE.NAME FOR OUTPUT AS FILE CGI_UPLOAD.CH,	&
		MAP FASTCGI_UPLOAD,	&
		ORGANIZATION SEQUENTIAL FIXED
	USE
		FILE.NAME	= ERT$(ERR)
		J1	= FASTCGI_LOCATE(J2, BOUNDARY)
		CONTINUE SAVE_UPLOAD_FINISH
	END WHEN


	J4	= 0%

SAVE_UPLOAD_LOOP:
	J3	= J2 + 511%
	J4	= J4 + 1%
	IF J3 <= J1 THEN
		STR::CNT		= 512%
		STR::PTR		= LOC(STDIN_CHAR(1%)) + J2 - 1%
		IF STR::CNT >= 0% THEN
			CALL FASTCGI_GET_STR(STR::CNT BY REF, UPLOAD_BUFFER)
			PUT #CGI_UPLOAD.CH
		ELSE
			PRINT '%NET-F-INVALID STRING COUNT ', STR::CNT
		END IF
		J2	= J2 + 512%
		GOTO SAVE_UPLOAD_LOOP IF J2 <= J1
	ELSE
		STR::CNT		= J1 - 1%
		STR::PTR		= LOC(STDIN_CHAR(1%)) + J2 - 1%
		IF STR::CNT >= 0% THEN
			CALL FASTCGI_GET_STR(STR::CNT BY REF, UPLOAD_BUFFER)
			PUT #CGI_UPLOAD.CH
		ELSE
			PRINT '%NET-F-INVALID STRING COUNT ', STR::CNT
		END IF
	END IF

SAVE_UPLOAD_FINISH:
	STDIN_PTR		= STDIN_PTR + 1%
	STDIN(STDIN_PTR, 0%)	= STDIN(STDIN_PTR - 1%, 0%) + '_VMS'
	STDIN(STDIN_PTR, 1%)	= FILE.NAME

	CLOSE #CGI_UPLOAD.CH

	GOTO DECODE_STDIN_M_LOOP

	!--------------------------------------------------------------

LOG_ERROR:
	GOSUB DUMP_DATA
	GOSUB ERROR_PAGE
	GOSUB OUTPUT_DATA
	RETURN

	!--------------------------------------------------------------

DUMP_DATA:
	PRINT ERR.MESS
	OPEN 'DSIERR:SERVER.DMP' FOR OUTPUT AS FILE DUMP.CH, recordsize 132%

	DUMP.STR	= ' : '
	PRINT #DUMP.CH; ERR.MESS
	PRINT #DUMP.CH; 'Read len = '; iosb(1%), 'Buffer pointer '; BUF.PTR
	FOR J0	= 1% TO iosb(1%)
		C0	= ASCII(IN_CHAR(J0))
		PRINT #DUMP.CH; FORMAT$(C0, ' ###');
		IF C0 > 31% THEN
			DUMP.STR	= DUMP.STR + CHR$(C0)
		ELSE
			DUMP.STR	= DUMP.STR + '.'
		END IF
		IF MOD(J0, 8%) = 0% THEN
			PRINT #DUMP.CH; DUMP.STR
			DUMP.STR	= ' : '
		END IF
	NEXT J0
	PRINT #DUMP.CH
	PRINT #DUMP.CH; '----------------- PARAMS -----------------------'
	PRINT FORMAT$(J0, '### ') + PARAMS(J0, 0%), PARAMS(J0, 1%) &
			FOR J0 = 1% TO PARAM_PTR
	PRINT #DUMP.CH
	PRINT #DUMP.CH; '------------------ STDIN -----------------------'
	PRINT FORMAT$(J0, '### ') + STDIN(J0, 0%), STDIN(J0, 1%) &
			FOR J0 = 1% TO STDIN_PTR
	RETURN

	!--------------------------------------------------------------

ERROR_PAGE:
	OUT.DATA	= 'Content-type: text/html' + CRLF + CRLF	&
			+ '<HTML>' + CRLF				&
			+ '<HEAD>' + CRLF				&
			+ '<TITLE>Invalid Data</TITLE>' + CRLF		&
			+ '</HEAD>' + CRLF				&
			+ '<BODY BGCOLOR="#FFFFFF">' + CRLF		&
			+ '<BR>' + CRLF					&
			+ ERR.MESS + CRLF				&
			+ '<BR>' + CRLF					&
			+ 'Please press "BACK"' + CRLF			&
			+ '<form>' + crlf				&
			+ '<input type="button" value="Back" '		&
			+ 'onClick = "history.back();">'		&
			+ '</form>' + crlf				&
			+ '<BR>' + CRLF					&
			+ '</BODY>' + CRLF				&
			+ '</BODY>' + CRLF				&
			+ '</HTML>' + CRLF				&
			+ CRLF
	RETURN

	!--------------------------------------------------------------

OUTPUT_DATA:
	OUT.PTR		= 0%

	OUT.TYPE	= FCGI_STDOUT
	OUT.LEN		= LEN(OUT.DATA)
	PAD.LEN		= 8% - MOD(OUT.LEN, 8%)
	PAD.LEN		= 0% IF PAD.LEN = 8%
	GOSUB INIT_HEADER

	OUT.PTR		= OUT.PTR + 1%
	MID(OUT_BUFFER, OUT.PTR, OUT.LEN + PAD.LEN)	= OUT.DATA &
			+ NULL8
	OUT.PTR		= OUT.PTR + OUT.LEN + PAD.LEN - 1%

	OUT.LEN		= 0%
	PAD.LEN		= 0%
	GOSUB INIT_HEADER

	OUT.TYPE	= FCGI_END_REQUEST
	OUT.LEN		= 8%
	GOSUB INIT_HEADER

	FOR J0 = 1% TO 8%
		OUT.PTR			= OUT.PTR + 1%
		OUT_BYTE(OUT.PTR)	= 0%
	NEXT J0

	CALL.STATUS = SYS$QIOW(,FASTCGI_CHANNEL_1 BY VALUE,	&
		IO$_WRITEVBLK BY VALUE,			&
		IOSB() BY REF,,,			&
		OUT_BUFFER BY REF,			&
		OUT.PTR BY VALUE,			&
		,,,)

	IF CALL.STATUS <> SS$_NORMAL THEN
		PRINT 'Write call status = '; CALL.STATUS
	END IF

	RETURN

	!--------------------------------------------------------------

INIT_HEADER:
	OUT.PTR			= OUT.PTR + 1%
	OUT_BYTE(OUT.PTR)	= 1%		! Version 1

	OUT.PTR			= OUT.PTR + 1%
	OUT_BYTE(OUT.PTR)	= OUT.TYPE

	OUT.PTR			= OUT.PTR + 1%
	OUT_CHAR(OUT.PTR)	= CHR$(REQ.ID/256%)

	OUT.PTR			= OUT.PTR + 1%
	OUT_CHAR(OUT.PTR)	= CHR$(REQ.ID AND 255%)

	OUT.PTR			= OUT.PTR + 1%
	OUT_CHAR(OUT.PTR)	= CHR$(OUT.LEN/256%)

	OUT.PTR			= OUT.PTR + 1%
	OUT_CHAR(OUT.PTR)	= CHR$(OUT.LEN AND 255%)

	OUT.PTR			= OUT.PTR + 1%
	OUT_BYTE(OUT.PTR)	= PAD.LEN

	OUT.PTR			= OUT.PTR + 1%
	OUT_BYTE(OUT.PTR)	= 0%
	RETURN

	!--------------------------------------------------------------

PROGRAM_ERROR:
	ERR.MESS	= 'Application logic error : ' + ERT$(ERR)
	GOSUB LOG_ERROR
	RESUME MAIN_LOOP

	!--------------------------------------------------------------

PROGRAM_END:
	SUBEND

	FUNCTION STRING DSI_URL_DECODE(STRING IN.DATA)
	! "A+B%26C" => "A B&C"

	DECLARE LONG	IN.LEN,		&
			IN.PTR,		&
			OUT.PTR

	DECLARE STRING	OUT.DATA

	RECORD ONE_CHAR_RECORD
	STRING	CHAR	= 1%
	END RECORD

	RECORD STR_RECORD
	VARIANT
	CASE
		STRING	STR_WHOLE	= 65535%
	CASE
		STRING	STR_CHAR(1% TO 65535%)	= 1%
	CASE
		BYTE	STR_BYTE(1% TO 65535%)
	END VARIANT
	END RECORD

	DECLARE ONE_CHAR_RECORD	TC
	DECLARE STR_RECORD	OD

	DECLARE STRING	CHAR2
	DECLARE BYTE	CHAR.VAL

	OUT.PTR	= 0%
	IN.LEN	= LEN(IN.DATA)
	IN.PTR	= 1%

LOOP:
	OUT.PTR		= OUT.PTR + 1%
	TC::CHAR	= MID(IN.DATA, IN.PTR, 1%)
	SELECT TC::CHAR
	CASE '+'
		OD::STR_CHAR(OUT.PTR)	= ' '
	CASE '%'
		IN.PTR		= IN.PTR + 1%
		CHAR2	= MID(IN.DATA, IN.PTR, 2%)
		CALL OTS$CVT_TZ_L(CHAR2, CHAR.VAL, 1% BY VALUE)
		OD::STR_BYTE(OUT.PTR)	= char.val
		IN.PTR		= IN.PTR + 1%
	CASE ELSE
		OD::STR_CHAR(OUT.PTR)	= TC::CHAR
	END SELECT
	IN.PTR	= IN.PTR + 1%
	GOTO LOOP IF IN.PTR <= IN.LEN

	DSI_URL_DECODE	= LEFT(OD::STR_WHOLE, OUT.PTR)

	END FUNCTION

	SUB FASTCGI_GET_STR(STRING IN.STR, OUT.STR)
	ON ERROR GOTO SUB_ERROR
	OUT.STR	= IN.STR
	SUBEXIT

SUB_ERROR:
	OUT.STR	= ''
	SUBEND
