	! Copyright (c) 2002 Digital Synergy, Inc.
	! See the file LICENSE.TXT for information on usage and redistribution
	! of this file, and for a DISCLAIMER OF ALL WARRANTIES.

	SUB FASTCGI_OUTPUT(STRING OUT.DATA)

	CALL FASTCGI_OUTPUT_DATA(OUT.DATA, -1%)

	SUBEND

	SUB FASTCGI_OUTPUT_SEG(STRING OUT.DATA)

	CALL FASTCGI_OUTPUT_DATA(OUT.DATA, 0%)

	SUBEND

	SUB FASTCGI_OUTPUT_DATA(STRING	OUT.DATA, LONG END.FLAG)

	%LET %BASIC$H_FLOATING_COMPLEX_DECL = 1
	%INCLUDE 'SYS$LIBRARY:UCX$INETDEF.BAS'

	!--------------------------------------------------------------
	! E X T E R N A L   D E C L A R A T I O N S
	!--------------------------------------------------------------

	EXTERNAL LONG FUNCTION		SYS$QIOW

	EXTERNAL LONG CONSTANT		SS$_NORMAL

	EXTERNAL WORD CONSTANT		IO$_WRITEVBLK

	DECLARE BYTE CONSTANT		FCGI_BEGIN_REQUEST	= 1%,	&
					FCGI_ABORT_REQUEST	= 2%,	&
					FCGI_END_REQUEST	= 3%,	&
					FCGI_PARAMS		= 4%,	&
					FCGI_STDIN		= 5%,	&
					FCGI_STDOUT		= 6%,	&
					FCGI_STDERR		= 7%,	&
					FCGI_DATA		= 8%,	&
					FCGI_GET_VALUES		= 9%,	&
					FCGI_GET_VALUES_RESULT	= 10%,	&
					FCGI_UNKNOWN		= 11%

	!--------------------------------------------------------------
	! C O N S T A N T S
	!--------------------------------------------------------------

	DECLARE STRING CONSTANT	NULL8	= '0'C + '0'C + '0'C + '0'C	&
					+ '0'C + '0'C + '0'C + '0'C

	!--------------------------------------------------------------
	! M A P S
	!--------------------------------------------------------------

	%INCLUDE 'SOURCE:FASTCGI_COMMON_MAP.INC'

	!--------------------------------------------------------------
	! V A R I A B L E S
	!--------------------------------------------------------------

	DECLARE LONG		CALL.STATUS,		&
				J0,			&
				OUT.LEN,		&
				OUT.PTR,		&
				OUT.TYPE,		&
				PAD.LEN

	DECLARE WORD		IOSB(3%),		&
				REQ.ID

	!--------------------------------------------------------------
	! F U N C T I O N S
	!--------------------------------------------------------------

	!--------------------------------------------------------------
	! I N I T I A L I Z A T I O N
	!--------------------------------------------------------------

	ON ERROR GOTO PROGRAM_ERROR

	OUT.PTR		= 0%
	REQ.ID		= 1%
	OUT.TYPE	= FCGI_STDOUT
	OUT.LEN		= LEN(OUT.DATA)
	PAD.LEN		= 8% - MOD(OUT.LEN, 8%)
	PAD.LEN		= 0% IF PAD.LEN = 8%
	GOSUB INIT_HEADER

	OUT.PTR		= OUT.PTR + 1%
	MID(OUT_BUFFER, OUT.PTR, OUT.LEN + PAD.LEN)	= OUT.DATA &
			+ NULL8
	OUT.PTR		= OUT.PTR + OUT.LEN + PAD.LEN - 1%

	IF END.FLAG THEN
		OUT.LEN		= 0%
		PAD.LEN		= 0%
		GOSUB INIT_HEADER

		OUT.TYPE	= FCGI_END_REQUEST
		OUT.LEN		= 8%
		GOSUB INIT_HEADER

		FOR J0 = 1% TO 8%
			OUT.PTR			= OUT.PTR + 1%
			OUT_BYTE(OUT.PTR)	= 0%
		NEXT J0
	END IF

	CALL.STATUS = SYS$QIOW(,FASTCGI_CHANNEL_1 BY VALUE,	&
		IO$_WRITEVBLK BY VALUE,				&
		IOSB() BY REF,,,				&
		OUT_BUFFER BY REF,				&
		OUT.PTR BY VALUE,				&
		,,,)

	IF CALL.STATUS <> SS$_NORMAL THEN
		PRINT 'Write call status = '; CALL.STATUS
	END IF

	SUBEXIT

	!--------------------------------------------------------------

INIT_HEADER:
	OUT.PTR			= OUT.PTR + 1%
	OUT_BYTE(OUT.PTR)	= 1%		! Version 1

	OUT.PTR			= OUT.PTR + 1%
	OUT_BYTE(OUT.PTR)	= OUT.TYPE

	OUT.PTR			= OUT.PTR + 1%
	OUT_CHAR(OUT.PTR)	= CHR$(REQ.ID/256%)

	OUT.PTR			= OUT.PTR + 1%
	OUT_CHAR(OUT.PTR)	= CHR$(REQ.ID AND 255%)

	OUT.PTR			= OUT.PTR + 1%
	OUT_CHAR(OUT.PTR)	= CHR$(OUT.LEN/256%)

	OUT.PTR			= OUT.PTR + 1%
	OUT_CHAR(OUT.PTR)	= CHR$(OUT.LEN AND 255%)

	OUT.PTR			= OUT.PTR + 1%
	OUT_BYTE(OUT.PTR)	= PAD.LEN

	OUT.PTR			= OUT.PTR + 1%
	OUT_BYTE(OUT.PTR)	= 0%
	RETURN

	!--------------------------------------------------------------

PROGRAM_ERROR:
	CALL PGMERR('FASTCGI_OUTPUT')

PROGRAM_END:
	SUBEND
