	SUB FASTCGI_SETUP(LONG	PORT.NUMBER)
	! Copyright (c) 2002 Digital Synergy, Inc.
	! See the file LICENSE.TXT for information on usage and redistribution
	! of this file, and for a DISCLAIMER OF ALL WARRANTIES.

	%LET %BASIC$H_FLOATING_COMPLEX_DECL = 1
	%INCLUDE 'SYS$LIBRARY:TCPIP$INETDEF.BAS'

	!--------------------------------------------------------------
	! E X T E R N A L   D E C L A R A T I O N S
	!--------------------------------------------------------------

	EXTERNAL LONG FUNCTION		LIB$GET_FOREIGN,	&
					SYS$ASSIGN,		&
					SYS$CANTIM,		&
					SYS$QIO,		&
					SYS$QIOW,		&
					SYS$SETIMR

	EXTERNAL LONG CONSTANT		SS$_NORMAL,		&
					SS$_ENDOFFILE,		&
					SS$_LINKDISCON

	EXTERNAL WORD CONSTANT		IO$_ACCESS,		&
					IO$_ACPCONTROL,		&
					IO$_DEACCESS,		&
					IO$_SETMODE,		&
					IO$_SENSEMODE,		&
					IO$_READVBLK,		&
					IO$_WRITEVBLK,		&
					IO$M_ACCEPT,		&
					IO$M_SHUTDOWN

	!--------------------------------------------------------------
	! R E C O R D S
	!--------------------------------------------------------------

	RECORD FLIP_RECORD
	VARIANT
	CASE
		WORD	W
	CASE
		BYTE	B1
		BYTE	B2
	END VARIANT
	END RECORD

	RECORD LOC_RECORD
	WORD	FAMILY
	WORD	PORT
	VARIANT
	CASE
		LONG	ADDR_LONG
	CASE
		STRING	ADDR_STR	= 4%
	CASE
		BYTE	ADDR(1% TO 4%)
	END VARIANT
	BYTE	X(1% TO 8%)
	END RECORD

	RECORD PAR11_RECORD
	WORD	PROTOCOL
	WORD	DATAGRAM
	END RECORD

	RECORD	PAR12_RECORD
	LONG	RET_LEN
	LONG	LOCAL_ADR
	END RECORD

	RECORD PAR_BLOCK
	VARIANT
	CASE
		STRING	STRING_PTR	= 4%
	CASE
		BYTE	SUB_FUNCTION
		BYTE	CALL_CODE
		WORD	RESERVED
	END VARIANT
	END RECORD

	RECORD	ITEM_OPT_RECORD
		WORD	LENGTH
		WORD	PTYPE
		LONG	ADDR
	END RECORD

	!--------------------------------------------------------------
	! C O N S T A N T S
	!--------------------------------------------------------------

	!--------------------------------------------------------------
	! M A P S
	!--------------------------------------------------------------

	%INCLUDE 'SOURCE:FASTCGI_COMMON_MAP.INC'

	!--------------------------------------------------------------
	! V A R I A B L E S
	!--------------------------------------------------------------

	DECLARE ITEM_OPT_RECORD	HDR,			&
				OP1

	DECLARE FLIP_RECORD	F1,			&
				F2

	DECLARE LONG		CALL.STATUS,		&
				OPT

	DECLARE PAR_BLOCK	PB

	DECLARE WORD		IOSB(3%)

	DECLARE LOC_RECORD	LOCAL_ADR,		&
				REMOTE_ADR

	DECLARE PAR11_RECORD	PAR11

	DECLARE PAR12_RECORD	PAR12

	!--------------------------------------------------------------
	! F U N C T I O N S
	!--------------------------------------------------------------

	!--------------------------------------------------------------
	! I N I T I A L I Z A T I O N
	!--------------------------------------------------------------

	ON ERROR GOTO PROGRAM_ERROR

	LOCAL_ADR::FAMILY	= TCPIP$C_AF_INET	! INET family
	F1::W			= PORT.NUMBER
	F2::B1			= F1::B2
	F2::B2			= F1::B1
	LOCAL_ADR::PORT		= F2::W		! Port number is byte reversed

	LOCAL_ADR::ADDR_LONG	= TCPIP$C_INADDR_ANY

	REMOTE_ADR::ADDR_STR	= LOCAL_ADR::ADDR_STR

	PAR11::PROTOCOL	= TCPIP$C_TCP
	PAR11::DATAGRAM	= INET_PROTYP$C_STREAM	! type of socket

	PAR12::RET_LEN		= 16%
	PAR12::LOCAL_ADR	= LOC(LOCAL_ADR::FAMILY)

	!--------------------------------------------------------------
	! Assign an INET device 
	!--------------------------------------------------------------

	! Assign FASTCGI_CHANNEL to the network device
	CALL.STATUS	= SYS$ASSIGN('TCPIP$DEVICE:', FASTCGI_CHANNEL,,)
	CALL PGMERR('Assign status = ' + NUM1$(CALL.STATUS))	&
		IF CALL.STATUS <> SS$_NORMAL

	!--------------------------------------------------------------
	! Create and bind the device Socket to the local host 
	!--------------------------------------------------------------

	HDR::LENGTH	= 8%
	HDR::PTYPE	= TCPIP$C_SOCKOPT
	HDR::ADDR	= LOC(OP1::LENGTH)

	OP1::LENGTH	= 4%
	OP1::PTYPE	= TCPIP$C_REUSEADDR
	OP1::ADDR	= LOC(OPT)

	OPT		= 1%
	CALL.STATUS	= SYS$QIOW(,FASTCGI_CHANNEL BY VALUE,	&
			IO$_SETMODE BY VALUE,	&
			IOSB() BY REF,,,	&
			PAR11::PROTOCOL BY REF,		! P1	&
			,				! P2	&
			,				! P3	&
			,				! P4	&
			LOC(HDR::LENGTH) BY VALUE,	! P5	&
			)				! P6
	CALL PGMERR('QIO set socket option status = ' + NUM1$(CALL.STATUS)) &
		IF CALL.STATUS <> SS$_NORMAL
	CALL PGMERR('QIO SET SOCKET IOSB(0) = ' + NUM1$(IOSB(0%)))	&
		IF IOSB(0%) <> SS$_NORMAL
	PRINT 'Port set'

	CALL.STATUS	= SYS$QIOW(,FASTCGI_CHANNEL BY VALUE,	&
			IO$_SETMODE BY VALUE,	&
			IOSB() BY REF,,,	&
			,			! P1	&
			,			! P2	&
			PAR12::RET_LEN BY REF,	! P3	&
			2% BY REF,		! P4	&
			,			! P5	&
			)			! P6
	CALL PGMERR('SETUP QIO BIND STATUS = ' + NUM1$(CALL.STATUS))	&
		IF CALL.STATUS <> SS$_NORMAL
	CALL PGMERR('SETUP QIO BIND IOSB(0) = ' + NUM1$(IOSB(0%)))	&
		IF IOSB(0%) <> SS$_NORMAL
	PRINT 'Port bound'

	START_TIME	= TIME(0)
	START_CPU	= TIME(1)
	START_ELAPSED	= 0.

	SUBEXIT

PROGRAM_ERROR:
	CALL PGMERR('FASTCGI_SETUP')

	SUBEND
