 	PROGRAM SAMPLE_NET
	! Sample Internet Application
	! Jeffrey H. Coffield / Digital Synergy, Inc.
	! 01-Feb-2000

	%INCLUDE 'SOURCE:FASTCGI_COMMON_MAP.INC'

	!--------------------------------------------------------------
	! R E C O R D S
	!--------------------------------------------------------------

	!--------------------------------------------------------------
	! C O N S T A N T S
	!--------------------------------------------------------------

	DECLARE LONG CONSTANT	FALSE	= 0%,	&
				TRUE	= -1%

	DECLARE STRING CONSTANT	CRLF	= CR + LF

	!--------------------------------------------------------------
	! M A P S
	!--------------------------------------------------------------

	!--------------------------------------------------------------
	! V A R I A B L E S
	!--------------------------------------------------------------

	DECLARE LONG	J0,			&
			J1,			&
			PORT.NUMBER

	DECLARE STRING	ERR.MESS,		&
			OUT.DATA,		&
			PAGE.INFO,		&
			PARAMS(1000%, 1%),	&
			REF.PAGE,		&
			RESULT.DATA,		&
			STDIN(1000%, 1%),	&
			WORK.AREA,		&
			WORK.STR

	!--------------------------------------------------------------
	! F U N C T I O N S
	!--------------------------------------------------------------

	DEF STRING PARAM_VALUE(STRING PARAM.NAME)
	DECLARE LONG	PV0

	FOR PV0	= 1% TO PARAM_PTR
		IF PARAMS(PV0, 0%) = PARAM.NAME THEN
			PARAM_VALUE	= PARAMS(PV0, 1%)
			GOTO PARAM_VALUE_EXIT
		END IF
	NEXT PV0
	PARAM_VALUE	= ''

PARAM_VALUE_EXIT:
	END DEF

	!--------------------------------------------------------------

	DEF STRING STDIN_VALUE(STRING STDIN.NAME)

	DECLARE LONG	SV0

	FOR SV0	= 1% TO STDIN_PTR
		IF STDIN(SV0, 0%) = STDIN.NAME THEN
			STDIN_VALUE	= STDIN(SV0, 1%)
			GOTO STDIN_VALUE_EXIT
		END IF
	NEXT SV0
	STDIN_VALUE	= ''
	PRINT 'No value for ' + STDIN.NAME

STDIN_VALUE_EXIT:
	END DEF

	!--------------------------------------------------------------
	! I N I T I A L I Z A T I O N
	!--------------------------------------------------------------

	ON ERROR GOTO PROGRAM_ERROR

	WHEN ERROR IN
		INPUT 'Port Number'; PORT.NUMBER
	USE
		CONTINUE PROGRAM_END
	END WHEN

	CALL FASTCGI_SETUP(PORT.NUMBER)

	PRINT 'Open for business...'

MAIN_LOOP:
	CALL FASTCGI_INPUT(PARAMS(,), STDIN(,))

	REF.PAGE	= PARAM_VALUE('REQUEST_URI')
	J0	= INSTR(0%, REF.PAGE, '/')
	J1	= INSTR(J0 + 1%, REF.PAGE, '/')
	J0	= INSTR(J1 + 1%, REF.PAGE, '/')
	WORK.AREA	= SEG$(REF.PAGE, J1 + 1%, J0 - 1%)
	print 'area = ' + WORK.AREA
	REF.PAGE	= RIGHT(REF.PAGE, J0 + 1%)
		! Drop /vms/<AREA>/

	J0	= INSTR(0%, REF.PAGE, '/')
	IF J0 THEN
		PAGE.INFO	= RIGHT(REF.PAGE, J0 + 1%)
		REF.PAGE	= LEFT(REF.PAGE, J0 - 1%)
	ELSE
		PAGE.INFO	= ''
	END IF

DISPATCH:
	PRINT '------------------------- ' + DATE$(0%) + ' ' + TIME$(0%) &
		+ ' ' + REF.PAGE

	GOSUB DUMP_DATA

	SELECT REF.PAGE
	CASE 'FLIP'
		GOSUB FLIP_DATA

	CASE ELSE
		ERR.MESS	= 'Unknown page <' + REF.PAGE + '>'
		GOSUB ERROR_PAGE
	END SELECT

OUTPUT_DATA:
	CALL FASTCGI_OUTPUT(OUT.DATA)

	GOTO MAIN_LOOP

	!--------------------------------------------------------------
	! S u b r o u t i n e s
	!--------------------------------------------------------------

FLIP_DATA:
	WORK.STR	= STDIN_VALUE('TEXT')
	RESULT.DATA	= ''
	RESULT.DATA	= MID(WORK.STR, J0, 1%) + RESULT.DATA	&
		FOR J0	= 1% TO LEN(WORK.STR)

	OUT.DATA	= 'Content-type: text/html' + CRLF + CRLF	&
		+ '<html>' + CRLF					&
		+ '<head>' + CRLF					&
		+ '<title>Test Results</title>' + CRLF			&
		+ '</head>' + CRLF					&
		+ '<body bgcolor="#ffffff">' + CRLF			&
		+ 'The result is <b>' + RESULT.DATA + '</b>'+ CRLF	&
		+ '<br>' + CRLF						&
		+ '</body>' + CRLF					&
		+ '</html>' + CRLF					&
		+ CRLF
	RETURN

	!--------------------------------------------------------------

ERROR_PAGE:
	OUT.DATA	= 'Content-type: text/html' + CRLF + CRLF	&
			+ '<HTML>' + CRLF				&
			+ '<HEAD>' + CRLF				&
			+ '<TITLE>Invalid Request</TITLE>' + CRLF	&
			+ '</HEAD>' + CRLF				&
			+ '<BODY BGCOLOR="#FFFFFF">' + CRLF		&
			+ '<BR>' + CRLF					&
			+ ERR.MESS + CRLF				&
			+ '<BR>' + CRLF					&
			+ '<form>' + CRLF				&
			+ '<input type="button" value="Home Page" '	&
			+ 'onClick = "location=' + "'/index.html'" + '">' &
			+ '</form>' + CRLF				&
			+ '<BR>' + CRLF					&
			+ '</BODY>' + CRLF				&
			+ '</BODY>' + CRLF				&
			+ '</HTML>' + CRLF				&
			+ CRLF
	RETURN

	!--------------------------------------------------------------

DUMP_DATA:
	PRINT
	PRINT '----------------- PARAMS -----------------------'
	PRINT FORMAT$(J0, '### ') + PARAMS(J0, 0%), PARAMS(J0, 1%) &
			FOR J0 = 1% TO PARAM_PTR
	PRINT
	PRINT '------------------ STDIN -----------------------'
	PRINT FORMAT$(J0, '### ') + STDIN(J0, 0%), STDIN(J0, 1%) &
			FOR J0 = 1% TO STDIN_PTR
	PRINT

	RETURN

	!--------------------------------------------------------------

PROGRAM_ERROR:
	PRINT 'PROGRAM_ERROR: ' + ERT$(ERR) + ' (' + NUM1$(ERR) + ')'
	ERR.MESS	= 'Application logic error : ' + ERT$(ERR)
	GOSUB ERROR_PAGE
	CALL FASTCGI_OUTPUT(OUT.DATA)

	RESUME MAIN_LOOP

PROGRAM_END:
	END
